require 'rails_helper'

# This spec was generated by jabysoft-base

<% module_namespacing do -%>
RSpec.describe <%= controller_class_name %>Controller, <%= type_metatag(:controller) %> do
  # This should return the minimal set of attributes required to create a valid
  # <%= class_name %>. As you add validations to <%= class_name %>, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) {
    build(:<%= file_name %>).attributes
  }

  let(:invalid_attributes) {
    skip("Add a hash of attributes invalid for your model")
  }
  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # <%= controller_class_name %>Controller. Be sure to keep this updated too.
  let(:valid_session) { {} }

<% unless options[:singleton] -%>
  describe 'GET #index' do
    before(:each) { get :index, params: {} }

    it 'renders the index template' do
      expect(response).to render_template(:index)
    end

    it 'returns http 200' do
      expect(response).to have_http_status(:success)
    end
  end

<% end -%>
  describe 'GET #show' do
    let(:<%= file_name %>) { <%= class_name %>.create! valid_attributes }
    before(:each) { get :show, params: {id: <%= file_name %>.to_param} }

    it 'renders the show template' do
      expect(response).to render_template(:show)
    end

    it 'returns http 200' do
      expect(response).to have_http_status(:success)
    end
  end

  describe 'GET #new' do
    before(:each) { get :new, params: {} }

    it 'renders the new template' do
      expect(response).to render_template(:new)
    end

    it 'returns http 200' do
      expect(response).to have_http_status(:success)
    end
  end

  describe 'GET #edit' do
    let(:<%= file_name %>) { <%= class_name %>.create! valid_attributes }
    before(:each) { get :edit, params: {id: <%= file_name %>.to_param} }

    it 'renders the edit template' do
      expect(response).to render_template(:edit)
    end

    it 'returns http 200' do
      expect(response).to have_http_status(:success)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      before(:each) { post :create, params: {<%= ns_file_name %>: valid_attributes}, session: valid_session }

      it 'creates a new <%= class_name %>' do
        expect {
          post :create, params: {<%= ns_file_name %>: valid_attributes}, session: valid_session
        }.to change(<%= class_name %>, :count).by(1)
      end

      it '<%= class_name %> should be found in database' do        
        <%= ns_file_name %> = <%= class_name %>.last
        expect(<%= ns_file_name %>.id.present?).to be true
      end

      it 'redirects to the created <%= ns_file_name %>' do
        expect(response).to redirect_to(<%= class_name %>.last)
      end
    end

    context 'with invalid params' do
      it "re-renders the 'new' template" do
        post :create, params: {<%= ns_file_name %>: invalid_attributes}, session: valid_session
        expect(response).to render_template(:new)
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) {
        skip("Add a hash of attributes valid for your model")
      }

      it 'updates the requested <%= ns_file_name %>' do
        <%= file_name %> = <%= class_name %>.create! valid_attributes
        put :update, params: {id: <%= file_name %>.to_param, <%= ns_file_name %>: new_attributes}, session: valid_session
        <%= file_name %>.reload
        skip("Add assertions for updated state")
      end

      it 'redirects to the <%= ns_file_name %>' do
        <%= file_name %> = <%= class_name %>.create! valid_attributes
        put :update, params: {id: <%= file_name %>.to_param, <%= ns_file_name %>: valid_attributes}, session: valid_session
        expect(response).to redirect_to(<%= file_name %>)
      end
    end

    context 'with invalid params' do
      it "re-renders the 'edit' template" do
        <%= file_name %> = <%= class_name %>.create! valid_attributes
        put :update, params: {id: <%= file_name %>.to_param, <%= ns_file_name %>: invalid_attributes}, session: valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    it 'destroys the requested <%= ns_file_name %>' do
      <%= file_name %> = <%= class_name %>.create! valid_attributes
      expect {
        delete :destroy, params: {id: <%= file_name %>.to_param}, session: valid_session
      }.to change(<%= class_name %>, :count).by(-1)
      expect(<%= class_name %>.find_by(id: <%= file_name %>.to_param)).to be nil
    end
    it 'redirects to the <%= table_name %> list' do
      <%= file_name %> = <%= class_name %>.create! valid_attributes
      delete :destroy, params: {id: <%= file_name %>.to_param}, session: valid_session
      expect(response).to redirect_to(<%= index_helper %>_url)
    end
  end
end
<% end -%>
